#include "sql.h"
#include "string.h"

/*----------------------------------------------------------------*/
/*								  */
/*  Example reading long data					  */
/*								  */
/*  Must compile and execute example 14 to create table and data  */
/*								  */
/*----------------------------------------------------------------*/

	  SQLTCUR   cur;		/* SQLBASE cursor number  */
	  SQLTRCD   rcd;		/* error number 	  */
	  char	    errmsg[SQLMERR];	/* error msg text buffer  */

	  main()
{
	  SQLTROW   rows;		/* number of rows	  */
	  int	    count;		/* saying number	  */
	  SQLTDAL   length;		/* length of data read	  */
	  char*     cp; 		/* character pointer	  */
	  char	    buf[40];		/* buffer to read long	  */

static	  char	    select [] = 	/* SELECT statement	  */
"SELECT SAY_NO, SAY_TEXT FROM SAYINGS";

  /*
    CONNECT TO THE DATABASE
  */

  if (rcd = sqlcnc(&cur, "DEMO", 0))
  {
    sqlerr(rcd, errmsg);		/* get error message text */
    printf("%s \n",errmsg);
    exit(1);
  }

  /*
    COMPILE SELECT STATEMENT
  */

  if (sqlcom(cur, select, 0))
    failure("COMPILE OF SELECT");

  /*
    SET SELECT BUFFER FOR SAYINGS NUMBER
  */

  if (sqlssb(cur, 1, SQLPUIN,(char*) &count,sizeof(count),0,SQLNPTR, SQLNPTR))
    failure("SET SELECT BUFFER");

  /*
    EXECUTE SELECT STATEMENT
  */

  if (sqlexe(cur))
    failure("EXECUTE OF SELECT");

  /*
    FETCH DATA
  */

  while (!(rcd = sqlfet(cur)))
  {
    printf("\nSAYING NUMBER %d \n",count);
    for (;;)				/* read long data	  */
    {
      memset(buf,' ',sizeof(buf));	/* clear input buffer	  */
      if (sqlrlo(cur, 2, buf, sizeof(buf) - 1, &length))
	failure("READING LONG DATA");

      if (!length)			/* end of long data?	  */
      {
	if (sqlelo(cur))		/* end long operation	  */
	  failure("ENDING LONG OPERATION");
	break;
      }
      buf[sizeof(buf) - 1] = '\0';	/* add string terminator  */
      while (cp = strchr(buf,'\n'))	/* remove newline char	  */
	*cp = ' ';
      while (cp = strchr(buf,'\t'))	/* remove tab characters  */
	*cp = ' ';
      printf("%s\n",buf);		/* print long data	  */
    }
  }

  if (rcd != 1)
    failure("FETCH");

  /*
    DISCONNECT FROM THE DATABASE
  */

  if (sqldis(cur))
    failure("DISCONNECT");
}
	  failure(ep)
	  char*     ep; 		/* -> failure msg string  */
{
	  SQLTEPO   epo;		/* error position	  */

  printf("Failure on %s \n", ep);
  sqlrcd(cur, &rcd);			/* get the error	  */
  sqlepo(cur, &epo);			/* get error position	  */
  sqlerr(rcd, errmsg);			/* get error message text */
  sqldis(cur);
  printf("%s (error: %u, position: %u) \n",errmsg,rcd,epo);
  exit(1);
}
